<template>
    <div class="row mb-3">
        <div class="col-md-6">
            <label for="">Select Country</label>
            <multiselect v-model="value" deselect-label="Can't remove this value" track-by="name" label="name" placeholder="Select Country" :options="options" :searchable="false" :allow-empty="false" @select="select">
            </multiselect>
        </div>
        <div class="col-md-6">
            <label for="">Validate Phone: <span class="badge badge-info">{{ formatInternational }}</span> - <span class="badge" :class="[ flag ? 'badge-success' : 'badge-danger']"> Valid {{ flag }}</span></label>
            <vuephonenumberinput v-model="phoneNumber" clearable @update="onUpdate"/>
        </div>
    </div>
</template>

<script>
    import {mapGetters,mapActions} from "vuex"
    export default {
        name: "search_country",
        props: {
            type: String,
            def_val: String
        },
        data() {
            return {
                value: null,
                phoneNumber: null,
                flag: false,
                formatInternational: ''
            }
        },
        methods: {
            ...mapActions({
                getDetails: 'fetchDetails'
            }),
            select: function(selected) {
                if(this.$props.type == "home")
                {
                    this.$router.push('/country/' + selected.code)
                } 
                else 
                {
                    this.getDetails(selected.code)
                }
            },
            onUpdate (payload) {
                console.log(payload);
                this.flag = payload.isValid
                this.results = payload
                this.formatInternational = payload.formatInternational
            }
        },
        computed: {
            ...mapGetters({
                options: 'options'
            })
        }, 
        mounted() {
            if(this.$props.def_val)
            {
                this.value = this.options.find(option => option.code === this.$props.def_val)
            }
            
        }
    }
</script>

<style scoped>

</style>